#!/usr/bin/python
import sys
import os
import time
import getopt
import socket
import ConfigParser
import struct
import binascii
ipaddress = str(sys.argv[1])
try:
    slave1id = int(sys.argv[2])
except:
    slave1id=0
try:
    slave2id = int(sys.argv[3])
except:
    slave2id=0
try:
    slave3id = int(sys.argv[4])
except:
    slave3id=0
try:
    slave4id = int(sys.argv[5])
except:
    slave4id=0
batwrsame = int(sys.argv[6])
extprodakt = int(sys.argv[7])

from pymodbus.client.sync import ModbusTcpClient
client = ModbusTcpClient(ipaddress, port=502)
#batterie auslesen und pv leistung korrigieren
storagepower = 0
if batwrsame == 1:
	# ################################################################
	# MOD START
	# ################################################################
	# BAT SOH
	# ################################################################
    rr = client.read_holding_registers(62850, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    batsoh = float(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_batsoh', 'w')
    f.write(str(batsoh))
    f.close()
	# ################################################################
	# BAT DC Ampere => -3.40282346639e+38 = 0
	# ################################################################	
    rr = client.read_holding_registers(62834, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    batamp = float(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_batamp', 'w')
    f.write(str(batamp))
    f.close()	
	# ################################################################
	# BAT DC Volt => -3.40282346639e+38 = 0
	# ################################################################	
    rr = client.read_holding_registers(62832, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    batdcvolt = float(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_batvolt', 'w')
    f.write(str(batdcvolt))
    f.close()
	# ################################################################
	# BAT TEMP
	# ################################################################	
    rr = client.read_holding_registers(62828, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    battemp = float(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_battemp', 'w')
    f.write(str(battemp))
    f.close()
	# ################################################################
	# BAT ENERGY AVAILABLE => eg 9170 (max. 9800) 
	# ################################################################
    rr = client.read_holding_registers(62848, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    batenergyavail = float(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_batenergyavail', 'w')
    f.write(str(batenergyavail))
    f.close()
	# ################################################################
	# BAT STATUS
	#  1 = Standby
	#  2 = Init
	#  3 = Laden
	#  4 = Entladen
	#  5 = Fehler
	#  6 = Erhaltungsladung
	#  7 = Unbekannt
	# 10 = Ruhemodus
    rr = client.read_holding_registers(62854, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    batstatus = int(struct.unpack('>i', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/_batstatus', 'w')
    f.write(str(batstatus))
    f.close()
	# ################################################################
	# MOD END
	# ################################################################	
    rr = client.read_holding_registers(62852, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    soc = int(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/speichersoc', 'w')
    f.write(str(soc))
    f.close()
    rr = client.read_holding_registers(62836, 2, unit=1)
    raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
    storagepower = int(struct.unpack('>f', raw)[0])
    f = open('/var/www/html/openWB/ramdisk/speicherleistung', 'w')
    f.write(str(storagepower))
    f.close()

	
try:
    resp= client.read_holding_registers(40083,2,unit=slave1id)
    #read watt
    watt=format(resp.registers[0], '04x')
    wr1watt=int(struct.unpack('>h', watt.decode('hex'))[0]) * -1
    #read multiplier
    multiplier=format(resp.registers[1], '04x')
    fmultiplier=int(struct.unpack('>h', multiplier.decode('hex'))[0])
    if fmultiplier == 0:
        fwr1watt = wr1watt
    if fmultiplier == -1:
        fwr1watt = wr1watt / 10
    if fmultiplier == -2:
        fwr1watt = wr1watt / 100
    if fmultiplier == -3:
        fwr1watt = wr1watt / 1000
    if fmultiplier == -4:
        fwr1watt = wr1watt / 10000
    if fmultiplier == -5:
        fwr1watt = wr1watt / 10000
except:
    fwr1watt=0
if slave2id != 0:
    try:
        resp= client.read_holding_registers(40083,2,unit=slave2id)
        #read watt
        watt=format(resp.registers[0], '04x')
        wr2watt=int(struct.unpack('>h', watt.decode('hex'))[0]) * -1
        #read multiplier
        multiplier=format(resp.registers[1], '04x')
        fmultiplier=int(struct.unpack('>h', multiplier.decode('hex'))[0])

        if fmultiplier == 0:
            fwr2watt = wr2watt
        if fmultiplier == -1:
            fwr2watt = wr2watt / 10
        if fmultiplier == -2:
            fwr2watt = wr2watt / 100
        if fmultiplier == -3:
            fwr2watt = wr2watt / 1000
        if fmultiplier == -4:
            fwr2watt = wr2watt / 10000
        if fmultiplier == -5:
            fwr2watt = wr2watt / 10000
    except:
        fwr2watt=0
else:
    fwr2watt=0
if slave3id != 0:
    try:
        resp= client.read_holding_registers(40083,2,unit=slave3id)
        #read watt
        watt=format(resp.registers[0], '04x')
        wr3watt=int(struct.unpack('>h', watt.decode('hex'))[0]) * -1
        #read multiplier
        multiplier=format(resp.registers[1], '04x')
        fmultiplier=int(struct.unpack('>h', multiplier.decode('hex'))[0])

        if fmultiplier == 0:
            fwr3watt = wr3watt
        if fmultiplier == -1:
            fwr3watt = wr3watt / 10
        if fmultiplier == -2:
            fwr3watt = wr3watt / 100
        if fmultiplier == -3:
            fwr3watt = wr3watt / 1000
        if fmultiplier == -4:
            fwr3watt = wr3watt / 10000
        if fmultiplier == -5:
            fwr3watt = wr3watt / 10000
    except:
        fwr3watt=0
else:
    fwr3watt=0
if slave4id != 0:
    try:
        resp= client.read_holding_registers(40083,2,unit=slave4id)
        #read watt
        watt=format(resp.registers[0], '04x')
        wr4watt=int(struct.unpack('>h', watt.decode('hex'))[0]) * -1
        #read multiplier
        multiplier=format(resp.registers[1], '04x')
        fmultiplier=int(struct.unpack('>h', multiplier.decode('hex'))[0])

        if fmultiplier == 0:
            fwr4watt = wr4watt
        if fmultiplier == -1:
            fwr4watt = wr4watt / 10
        if fmultiplier == -2:
            fwr4watt = wr4watt / 100
        if fmultiplier == -3:
            fwr4watt = wr4watt / 1000
        if fmultiplier == -4:
            fwr4watt = wr4watt / 10000
        if fmultiplier == -5:
            fwr4watt = wr4watt / 10000
    except:
        fwr4watt=0
else:
    fwr4watt=0


if extprodakt == 1:    
    resp= client.read_holding_registers(40380,1,unit=slave1id)
    value1 = resp.registers[0]
    all = format(value1, '04x')
    extprod = int(struct.unpack('>h', all.decode('hex'))[0]) * -1
else:
    extprod = 0
allwatt=fwr1watt+fwr2watt+fwr3watt+fwr4watt-storagepower+extprod
f = open('/var/www/html/openWB/ramdisk/pvwatt', 'w')
f.write(str(allwatt))
f.close()


# MOD START
resp= client.read_holding_registers(40093,2,unit=slave1id)
value1 = resp.registers[0]
value2 = resp.registers[1]
all = format(value1, '04x') + format(value2, '04x')
final_wr1 = int(struct.unpack('>i', all.decode('hex'))[0])
final_wr1_2 = final_wr1
f = open('/var/www/html/openWB/ramdisk/pvkwh', 'w')
f.write(str(final_wr1))
f.close()
f2 = open('/var/www/html/openWB/ramdisk/_pv1totalwh', 'w')
f2.write(str(final_wr1_2))
f2.close()
# MOD END


pvkwhk= final_wr1 / 1000
f = open('/var/www/html/openWB/ramdisk/pvkwhk', 'w')
f.write(str(pvkwhk))
f.close()


# ################################################################
# MOD START
# ################################################################
# ################################################################
# WR1 Temp
# ################################################################

resp= client.read_holding_registers(40103,5,unit=slave1id)
raw=format(resp.registers[0], '04x')
wr1temp=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[3], '04x')
fmultiplier=float(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr1temp = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:
   fwr1temp = wr1temp
if fmultiplier == -1:
   fwr1temp = wr1temp / 10
if fmultiplier == -2:
   fwr1temp = wr1temp / 100
if fmultiplier == -3:
   fwr1temp = wr1temp / 1000
if fmultiplier == -4:
   fwr1temp = wr1temp / 10000
if fmultiplier == -5:
   fwr1temp = wr1temp / 10000
f = open('/var/www/html/openWB/ramdisk/_wr1temp', 'w')
f.write(str(fwr1temp))
f.close()


# ################################################################
# WR1 status
# ################################################################
resp= client.read_holding_registers(40107,1,unit=slave1id)
raw=format(resp.registers[0], '04x')
wr1status=int(struct.unpack('>h', raw.decode('hex'))[0])
f = open('/var/www/html/openWB/ramdisk/_wr1status', 'w')
f.write(str(wr1status))
f.close()


# ################################################################
# WR1 DC Voltage
# ################################################################
resp= client.read_holding_registers(40098,2,unit=slave1id)
raw=format(resp.registers[0], '04x')
wr1volt=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[1], '04x')
fmultiplier=float(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr1volt = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:
   fwr1volt = wr1volt
if fmultiplier == -1:
   fwr1volt = wr1volt / 10
if fmultiplier == -2:
   fwr1volt = wr1volt / 100
if fmultiplier == -3:
   fwr1volt = wr1volt / 1000
if fmultiplier == -4:
   fwr1volt = wr1volt / 10000
if fmultiplier == -5:
   fwr1volt = wr1volt / 10000
f = open('/var/www/html/openWB/ramdisk/_wr1volt', 'w')
f.write(str(fwr1volt))
f.close()


# ################################################################
# WR1 DC Ampere
# ################################################################
resp= client.read_holding_registers(40096,2,unit=slave1id)
raw=format(resp.registers[0], '04x')
wr1amp=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[1], '04x')
fmultiplier=int(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr1amp = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:
   fwr1amp = wr1amp
if fmultiplier == -1:
   fwr1amp = wr1amp / 10
if fmultiplier == -2:
   fwr1amp = wr1amp / 100
if fmultiplier == -3:
   fwr1amp = wr1amp / 1000
if fmultiplier == -4:
   fwr1amp = wr1amp / 10000
if fmultiplier == -5:
   fwr1amp = wr1amp / 100000     
f = open('/var/www/html/openWB/ramdisk/_wr1amp', 'w')
f.write(str(fwr1amp))
f.close()


# ################################################################
# WR2 PV TOTAL
# ################################################################
resp= client.read_holding_registers(40093,2,unit=slave2id)
value1 = resp.registers[0]
value2 = resp.registers[1]
all = format(value1, '04x') + format(value2, '04x')
final_wr2 = int(struct.unpack('>i', all.decode('hex'))[0])
f4 = open('/var/www/html/openWB/ramdisk/_pv2totalwh', 'w')
f4.write(str(final_wr2))
f4.close()


# ################################################################
# WR2 Temp
# ################################################################
resp= client.read_holding_registers(40103,5,unit=slave2id)
raw=format(resp.registers[0], '04x')
wr1temp=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[3], '04x')
fmultiplier=float(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr1temp = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:
   fwr1temp = wr1temp
if fmultiplier == -1:
   fwr1temp = wr1temp / 10
if fmultiplier == -2:
   fwr1temp = wr1temp / 100
if fmultiplier == -3:
   fwr1temp = wr1temp / 1000
if fmultiplier == -4:
   fwr1temp = wr1temp / 10000
if fmultiplier == -5:
   fwr1temp = wr1temp / 10000
f = open('/var/www/html/openWB/ramdisk/_wr2temp', 'w')
f.write(str(fwr1temp))
f.close()


# ################################################################
# WR2 status
# ################################################################
resp= client.read_holding_registers(40107,1,unit=slave2id)
raw=format(resp.registers[0], '04x')
wr2status=int(struct.unpack('>h', raw.decode('hex'))[0])
f = open('/var/www/html/openWB/ramdisk/_wr2status', 'w')
f.write(str(wr2status))
f.close()


# ################################################################
# WR2 DC Voltage
# ################################################################
resp= client.read_holding_registers(40098,2,unit=slave2id)
raw=format(resp.registers[0], '04x')
wr2volt=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[1], '04x')
fmultiplier=float(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr2volt = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:   fwr2volt = wr2volt
if fmultiplier == -1:
   fwr2volt = wr2volt / 10
if fmultiplier == -2:
   fwr2volt = wr2volt / 100
if fmultiplier == -3:
   fwr2volt = wr2volt / 1000
if fmultiplier == -4:
   fwr2volt = wr2volt / 10000
if fmultiplier == -5:
   fwr2volt = wr2volt / 10000
f = open('/var/www/html/openWB/ramdisk/_wr2volt', 'w')
f.write(str(fwr2volt))
f.close()


# ################################################################
# WR2 DC Ampere
# ################################################################
resp= client.read_holding_registers(40096,2,unit=slave2id)
raw=format(resp.registers[0], '04x')
wr2amp=float(struct.unpack('>h', raw.decode('hex'))[0])
multiplier=format(resp.registers[1], '04x')
fmultiplier=float(struct.unpack('>h', multiplier.decode('hex'))[0])
fwr2amp = 0 # Fallback in case of multiplier fail
if fmultiplier == 0:
   fwr2amp = wr2amp
if fmultiplier == -1:
   fwr2amp = wr2amp / 10
if fmultiplier == -2:
   fwr2amp = wr2amp / 100
if fmultiplier == -3:
   fwr2amp = wr2amp / 1000
if fmultiplier == -4:
   fwr2amp = wr2amp / 10000
if fmultiplier == -5:
   fwr2amp = wr2amp / 100000 
f = open('/var/www/html/openWB/ramdisk/_wr2amp', 'w')
f.write(str(fwr2amp))
f.close()
# ################################################################
# MOD END
# ################################################################




